#include <iostream>
using namespace std;
int main()
{
    int a[50][50],M,N,P,sum=0,br=0,m=0;
    cin >> M >> N >> P;
    for(int i=0; i<N; i++)
    {
        for(int j=0; j<N; j++)
        {
            if(br<N-m)
            {
                a[i][j]=M+j;
                br++;
            }
            while(br!=0)
            {
                a[j][N-m]=M+j;
                br--;
            }
        }
    }
    for(int i=0; i<N; i++)
    {
        for(int j=0; j<N; j++)
        {
            cout << a[i][j];
            if(j==N-1)
            {
                cout << endl;
            }
        }
    }
    for(int i=0; i<N; i++)
    {
        sum+=a[P][i];
    }
    cout << sum;
    cout << endl;
    return 0;
}
